﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Microsoft.SharePoint.Client;
using MVC4Web.Models;

namespace MVC4Web.Controllers
{
    public class ContactsController : Controller
    {

        public ActionResult Index()
        {
            return View();
        }

        public ActionResult ReadAll(string SPHostUrl, string SPLanguage, string SPAppWebUrl, string SPHostTitle)
        {
            using (ClientContext ctx = new ClientContext(SPAppWebUrl))
            {
                //Read the Site, List, and Items
                ctx.Load(ctx.Web);

                List list = ctx.Web.Lists.GetByTitle("Contacts");
                ctx.Load(list);

                StringBuilder caml = new StringBuilder();
                caml.Append("<View><Query><OrderBy/></Query>");
                caml.Append("<ViewFields><FieldRef Name='ID'/><FieldRef Name='FirstName'/>");
                caml.Append("<FieldRef Name='Title'/><FieldRef Name='WorkPhone'/></ViewFields>");
                caml.Append("<RowLimit>100</RowLimit></View>");

                CamlQuery query = new CamlQuery();
                query.ViewXml = caml.ToString();
                Microsoft.SharePoint.Client.ListItemCollection listItems = list.GetItems(query);
                ctx.Load(listItems);
                ctx.ExecuteQuery();

                List<Contact> contacts = new List<Contact>();

                foreach (ListItem listItem in listItems)
                {
                    Contact contact = new Contact()
                    {
                        Id = listItem["ID"].ToString(),
                        LastName = listItem["Title"].ToString(),
                        FirstName = listItem["FirstName"].ToString(),
                        WorkPhone = listItem["WorkPhone"].ToString()
                    };
                    contacts.Add(contact);
                }

                ViewBag.Contacts = contacts;
            }

            return View();
        }

    }
}
