﻿window.Wingtip = window.Wingtip || {};
window.Wingtip.ResponseDocument;
window.Wingtip.Song = function (al, ti, ar) {

    //private members
    var album = 'undefined',
        title = 'undefined',
        artist = 'undefined',
        set_album = function (v) { album = v; },
        get_album = function () { return album; },
        set_title = function (v) { title = v; },
        get_title = function () { return title; },
        set_atist = function (v) { artist = v; },
        get_artist = function () { return artist; };


    //Constructor
    album = al;
    title = ti;
    artist = ar;

    //public interface
    return {
        set_album: set_album,
        get_album: get_album,
        set_title: set_title,
        get_title: get_title,
        set_atist: set_atist,
        get_artist: get_artist
    };
}

window.Wingtip.SongViewModel = function () {

    //private members
    var songs = ko.observableArray(),
        get_songs = function () { return songs; },

        init = function () {
            $("#search").click(function () {
                load($("#keyword").attr("value"));
            });
        },

        load = function (artist) {

            var ctx = SP.ClientContext.get_current();
            var request = new SP.WebRequestInfo();

            request.set_url(
                "http://www.musicbrainz.org/ws/2/recording?query=artist:" + artist
                );
            request.set_method("GET");
            window.Wingtip.ResponseDocument = SP.WebProxy.invoke(ctx, request);

            ctx.executeQueryAsync(onSuccess, onError);

        },

        onSuccess = function () {
            var xmlDoc = $.parseXML(window.Wingtip.ResponseDocument.get_body());

            songs.removeAll();

            $(xmlDoc).find("recording").each(function (i) {
                songs.push(
                    new Wingtip.Song(
                    $(this).children("release-list").first().children("release").first().children("title").first().text(),
                    $(this).children("release-list").first().children("release").first().children("medium-list").first().find("title").text(),
                    $(this).find("name").first().text()));
            });

        },

        onError = function (err) {
            alert(JSON.stringify(err));
        };


    //public interface
    return {
        init: init,
        get_songs: get_songs
    };

}();
