﻿window.Wingtip = window.Wingtip || {};
Wingtip.Contacts;
Wingtip.ContactList = function () {

    //private members
    createItem = function (lname, fname, wphone) {
        var ctx = new SP.ClientContext.get_current();
        var list = ctx.get_web().get_lists().getByTitle("Contacts");
        ctx.load(list);
        var listItemCreationInfo = new SP.ListItemCreationInformation();
        var newContact = list.addItem(listItemCreationInfo);
        newContact.set_item("Title", lname);
        newContact.set_item("FirstName", fname);
        newContact.set_item("WorkPhone", wphone);
        newContact.update();
        ctx.executeQueryAsync(success, error);
    },

    readAll = function () {
        var ctx = new SP.ClientContext.get_current();
        var query = "<View><Query><OrderBy><FieldRef Name='Title'/><FieldRef Name='FirstName'/></OrderBy></Query><ViewFields><FieldRef Name='ID'/><FieldRef Name='Title'/><FieldRef Name='FirstName'/><FieldRef Name='WorkPhone'/></ViewFields></View>";
        var camlQuery = new SP.CamlQuery();
        camlQuery.set_viewXml(query);
        var list = ctx.get_web().get_lists().getByTitle("Contacts");
        ctx.load(list);
        Wingtip.Contacts = list.getItems(camlQuery);
        ctx.load(Wingtip.Contacts, 'Include(ID,Title,FirstName,WorkPhone)');
        ctx.executeQueryAsync(readAllSuccess, error);
    },

    readAllSuccess = function () {

        var html = [];
        html.push("<table><thead><tr><th>ID</th><th>First Name</th><th>Last Name</th><th>Title</th></tr></thead>");

        var listItemEnumerator = Wingtip.Contacts.getEnumerator();

        while (listItemEnumerator.moveNext()) {
            var listItem = listItemEnumerator.get_current();
            html.push("<tr>");
            html.push("<td>");
            html.push(listItem.get_item("ID"));
            html.push("</td>");
            html.push("<td>");
            html.push(listItem.get_item("FirstName"));
            html.push("</td>");
            html.push("<td>");
            html.push(listItem.get_item("Title"));
            html.push("</td>");
            html.push("<td>");
            html.push(listItem.get_item("WorkPhone"));
            html.push("</td>");
            html.push("</tr>");
        }

        html.push("</table>");
        $('#displayDiv').html(html.join(''));
    },

    updateItem = function (id, lname, fname, wphone) {
        var ctx = new SP.ClientContext.get_current();
        var list = ctx.get_web().get_lists().getByTitle("Contacts");
        ctx.load(list);
        var listItem = list.getItemById(id);
        listItem.set_item("Title", lname);
        listItem.set_item("FirstName", fname);
        listItem.set_item("WorkPhone", wphone);
        listItem.update();
        ctx.executeQueryAsync(success, error);
    },

    removeItem = function (id) {
        var ctx = new SP.ClientContext.get_current();
        var list = ctx.get_web().get_lists().getByTitle("Contacts");
        ctx.load(list);
        var listItem = list.getItemById(id);
        listItem.deleteObject();
        ctx.executeQueryAsync(success, error);
    },

    success = function () {
        readAll();
    },

    error = function (sender, args) {
        alert(args.get_message());
    }

    //public interface
    return {
        createContact: createItem,
        updateContact: updateItem,
        deleteContact: removeItem
    }

}();

$(document).ready(function () {
    Wingtip.ContactList.createContact("Cox", "Brian", "555-555-5555");
    alert("Contact Created!");
    Wingtip.ContactList.updateContact(1, "Cox", "Brian", "111-111-1111");
    alert("Contact Updated!");
    Wingtip.ContactList.deleteContact(1);
    alert("Contact Deleted!");
});