﻿"use strict";

var WingtipToys = window.WingtipToys || {};
WingtipToys.Jsom = WingtipToys.Jsom || {};

WingtipToys.Jsom.Libs = function () {

    var deferreds = new Array(),

    create = function (title, description) {
        deferreds[deferreds.length] = $.Deferred();
        var ctx = new SP.ClientContext.get_current();
        var createInfo = new SP.ListCreationInformation();
        createInfo.set_title(title);
        createInfo.set_description(description);
        createInfo.set_templateType(SP.ListTemplateType.documentLibrary);
        this.newLib = ctx.get_web().get_lists().add(createInfo);
        ctx.load(this.newLib);
        this.newLib.set_contentTypesEnabled(true);
        this.newLib.update();
        ctx.executeQueryAsync(
            Function.createDelegate(this,
                function () { deferreds[deferreds.length - 1].resolve(this.newLib); }),
            Function.createDelegate(this,
                function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

        return deferreds[deferreds.length - 1].promise();

    },

    remove = function (title) {
        deferreds[deferreds.length] = $.Deferred();
        var ctx = new SP.ClientContext.get_current();
        var list = ctx.get_web().get_lists().getByTitle(title)
        ctx.load(list);
        this.oldTitle = title;
        list.deleteObject();
        ctx.executeQueryAsync(
            Function.createDelegate(this,
                function () { deferreds[deferreds.length - 1].resolve(this.oldTitle); }),
            Function.createDelegate(this,
                function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

        return deferreds[deferreds.length - 1].promise();

    },

    upload = function (serverRelativeUrl, filename, file) {
        deferreds[deferreds.length] = $.Deferred();

        getFileBuffer(file).then(

            function (buffer) {

                var bytes = new Uint8Array(buffer);
                var content = new SP.Base64EncodedByteArray();
                for (var b = 0; b < bytes.length; b++) {
                    content.append(bytes[b]);
                }
                var ctx = new SP.ClientContext.get_current();
                var createInfo = new SP.FileCreationInformation();
                createInfo.set_content(content);
                createInfo.set_overwrite(true);
                createInfo.set_url(filename);
                this.files = ctx.get_web().getFolderByServerRelativeUrl(serverRelativeUrl).get_files();
                ctx.load(this.files);
                this.files.add(createInfo);
                ctx.executeQueryAsync(
                    Function.createDelegate(this,
                        function () { deferreds[deferreds.length - 1].resolve(this.files); }),
                    Function.createDelegate(this,
                        function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

            },
            function (err) {
                deferreds[deferreds.length - 1].reject(err);
            }
         );

        return deferreds[deferreds.length - 1].promise();

    },

    setLibraryTemplate = function (contentTypeId, documentTemplateUrl) {
        deferreds[deferreds.length] = $.Deferred();
        var ctx = new SP.ClientContext.get_current();
        this.library = ctx.get_web().get_lists().getByTitle(title)
        ctx.load(this.library);
        this.library.set_documentTemplateUrl(documentTemplateUrl);
        this.library.update();
        ctx.executeQueryAsync(
            Function.createDelegate(this,
                function () { deferreds[deferreds.length - 1].resolve(this.library); }),
            Function.createDelegate(this,
                function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

        return deferreds[deferreds.length - 1].promise();

    },

    setCTypeTemplate = function (contentTypeId, documentTemplateUrl) {
        deferreds[deferreds.length] = $.Deferred();
        var ctx = new SP.ClientContext.get_current();
        this.ctype = ctx.get_web().get_contentTypes().getById(contentTypeId)
        ctx.load(this.ctype);
        this.ctype.set_documentTemplate(documentTemplateUrl);
        this.ctype.update();
        ctx.executeQueryAsync(
            Function.createDelegate(this,
                function () { deferreds[deferreds.length - 1].resolve(this.ctype); }),
            Function.createDelegate(this,
                function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

        return deferreds[deferreds.length - 1].promise();

    },

    getFileBuffer = function (file) {
        var deferred = $.Deferred();
        var reader = new FileReader();
        reader.onload = function (e) {
            deferred.resolve(e.target.result);
        }
        reader.onerror = function (e) {
            deferred.reject(e.target.error);
        }
        reader.readAsArrayBuffer(file);
        return deferred.promise();
    },

    createContentType = function (contentTypeName, description) {
        deferreds[deferreds.length] = $.Deferred();
        var ctx = new SP.ClientContext.get_current();
        var parent = ctx.get_web().get_contentTypes().getById("0x0101");
        ctx.load(parent);
        var createInfo = new SP.ContentTypeCreationInformation();
        createInfo.set_name(contentTypeName);
        createInfo.set_description(description);
        createInfo.set_parentContentType(parent);
        this.newCtype = ctx.get_web().get_contentTypes().add(createInfo);
        ctx.load(this.newCtype);
        ctx.executeQueryAsync(
            Function.createDelegate(this,
                function () { deferreds[deferreds.length - 1].resolve(this.newCtype); }),
            Function.createDelegate(this,
                function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

        return deferreds[deferreds.length - 1].promise();

    },

    getContentType = function (contentTypeId) {
        deferreds[deferreds.length] = $.Deferred();
        var ctx = new SP.ClientContext.get_current();
        this.ctype = ctx.get_web().get_contentTypes().getById(contentTypeId);
        ctx.load(this.ctype);
        ctx.executeQueryAsync(
            Function.createDelegate(this,
                function () { deferreds[deferreds.length - 1].resolve(this.ctype); }),
            Function.createDelegate(this,
                function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

        return deferreds[deferreds.length - 1].promise();

    },

    bindContentType = function (libraryTitle, contentTypeId) {
        deferreds[deferreds.length] = $.Deferred();
        var ctx = new SP.ClientContext.get_current();
        var library = ctx.get_web().get_lists().getByTitle(libraryTitle);
        ctx.load(library);
        this.ctype = ctx.get_web().get_contentTypes().getById(contentTypeId);
        ctx.load(this.ctype);
        library.get_contentTypes().addExistingContentType(this.ctype);
        ctx.executeQueryAsync(
            Function.createDelegate(this,
                function () { deferreds[deferreds.length - 1].resolve(this.ctype); }),
            Function.createDelegate(this,
                function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

        return deferreds[deferreds.length - 1].promise();

    },

    addFieldLink = function (contentTypeId, internalFieldName) {
        deferreds[deferreds.length] = $.Deferred();
        var ctx = new SP.ClientContext.get_current();
        var ctype;
        var field;
        ctype = ctx.get_web().get_contentTypes().getById(contentTypeId);
        field = ctx.get_web().get_fields().getByInternalNameOrTitle(internalFieldName);
        ctx.load(ctype);
        ctx.load(field);
        var createInfo = new SP.FieldLinkCreationInformation();
        createInfo.set_field(field);
        this.fieldLink = ctype.get_fieldLinks().add(createInfo);
        ctype.update(true);
        ctx.load(this.fieldLink);
        ctx.executeQueryAsync(
        Function.createDelegate(this,
            function () { deferreds[deferreds.length - 1].resolve(this.fieldLink); }),
        Function.createDelegate(this,
            function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

        return deferreds[deferreds.length - 1].promise();

    };

    return {
        create: create,
        remove: remove,
        upload: upload,
        set_libraryTemplate: setLibraryTemplate,
        set_ctypeTemplate:setCTypeTemplate,
        create_contentType: createContentType,
        get_contentType: getContentType,
        bind_contentType: bindContentType,
        add_fieldLink: addFieldLink
    };

}();