﻿"use strict";

var WingtipToys = window.WingtipToys || {};
WingtipToys.Rest = WingtipToys.Rest || {};

WingtipToys.Rest.Fields = function () {

    var addField = function (listTitle, fieldDisplayName, fieldType) {

        var deferred = $.ajax(
            {
                url: _spPageContextInfo.webServerRelativeUrl +
                    "/_api/web/lists/getByTitle('" + listTitle + "')" +
                    "/fields",
                type: "POST",
                contentType: "application/json;odata=verbose",
                data: JSON.stringify(
                    {
                        '__metadata': {
                            'type': 'SP.Field'
                        },
                        'Title': fieldDisplayName,
                        'FieldTypeKind': fieldType
                    }),
                headers: {
                    "accept": "application/json;odata=verbose",
                    "X-RequestDigest": $("#__REQUESTDIGEST").val()
                }
            }
        );

        return deferred.promise()
    },

    addSiteColumn = function (fieldDisplayName, fieldType, local) {

        var scope;
        if (local === true) {
            scope = "/_api/web/fields";
        }
        else {
            scope = "/_api/site/rootWeb/fields";
        }

        var deferred = $.ajax(
            {
                url: _spPageContextInfo.webServerRelativeUrl + scope,
                type: "POST",
                contentType: "application/json;odata=verbose",
                data: JSON.stringify(
                    {
                        '__metadata': {
                            'type': 'SP.Field'
                        },
                        'Title': fieldDisplayName,
                        'FieldTypeKind': fieldType,
                        'Group': 'Wingtip Toys'
                    }),
                headers: {
                    "accept": "application/json;odata=verbose",
                    "X-RequestDigest": $("#__REQUESTDIGEST").val()
                }
            }
        );

        return deferred.promise()
    },

    addSiteColumnChoice = function (internalFieldName, schema, local) {

        var scope;
        if (local === true) {
            scope = "/_api/web/fields";
        }
        else {
            scope = "/_api/site/rootWeb/fields";
        }

        var deferred = $.ajax(
            {
                url: _spPageContextInfo.webServerRelativeUrl + scope +
                    "/getByInternalNameOrTitle('" + internalFieldName + "')",
                    //"/updateAndPushChanges(true)",
                type: "POST",
                contentType: "application/json;odata=verbose",
                data: JSON.stringify(
                    {
                        '__metadata': {
                            'type': 'SP.FieldChoice'
                        },
                        'SchemaXml': schema
                    }),
                headers: {
                    "accept": "application/json;odata=verbose",
                    "X-RequestDigest": $("#__REQUESTDIGEST").val(),
                    "IF-MATCH": "*",
                    "X-Http-Method": "PATCH"
            }
            }
        );

        return deferred.promise()
    },

    getField = function (listTitle, internalFieldName) {
        var deferred = $.ajax(
            {
                url: _spPageContextInfo.webServerRelativeUrl +
                    "/_api/web/lists/getByTitle('" + listTitle + "')" +
                    "/fields/getByInternalNameOrTitle('" + internalFieldName + "')",
                type: "GET",
                headers: {
                    "accept": "application/json;odata=verbose",
                }
            }
        );

        return deferred.promise()
    },

    getSiteColumn = function (internalFieldName) {
        var deferred = $.ajax(
            {
                url: _spPageContextInfo.webServerRelativeUrl +
                    "/_api/web/availableFields/getByInternalNameOrTitle('" + internalFieldName + "')",
                type: "GET",
                headers: {
                    "accept": "application/json;odata=verbose",
                }
            }
        );

        return deferred.promise()
    },

    setDisplayName = function (listTitle, internalFieldName, displayFieldName) {

        var deferred = $.ajax(
        {
            url: _spPageContextInfo.webServerRelativeUrl +
                "/_api/web/lists/getByTitle('" + listTitle + "')" +
                "/fields/getByInternalNameOrTitle('" + internalFieldName + "')",
            type: "POST",
            contentType: "application/json;odata=verbose",
            data: JSON.stringify(
                {
                    '__metadata': {
                        'type': 'SP.Field'
                    },
                    'Title': displayFieldName
                }),
            headers: {
                "accept": "application/json;odata=verbose",
                "X-RequestDigest": $("#__REQUESTDIGEST").val(),
                "IF-MATCH": "*",
                "X-Http-Method": "PATCH"
            }
        }
    );

        return deferred.promise()

    };

    return {
        add_field: addField,
        add_siteColumn: addSiteColumn,
        add_siteColumnChoice: addSiteColumnChoice,
        get_field: getField,
        get_siteColumn: getSiteColumn,
        set_displayName: setDisplayName
    };

}();