﻿"use strict";

var WingtipToys = window.WingtipToys || {}
WingtipToys.Rest = WingtipToys.Rest || {}

WingtipToys.Rest.Lists = function () {

    var create = function (title, description, template) {
        var deferred = $.ajax({
            url: _spPageContextInfo.webServerRelativeUrl +
                 "/_api/web/lists",
            type: "POST",
            contentType: "application/json;odata=verbose",
            data: JSON.stringify(
                {
                    '__metadata': {
                        'type': 'SP.List'
                    },
                    'Title': title,
                    'Description': description,
                    'BaseTemplate': template,
                    'AllowContentTypes': true,
                    'ContentTypesEnabled': true
                }),
            headers: {
                "accept": "application/json;odata=verbose",
                "X-RequestDigest": $("#__REQUESTDIGEST").val()
            }
        });

        return deferred.promise()
    },

    remove = function (title) {
        var deferred = $.ajax(
            {
                url: _spPageContextInfo.webServerRelativeUrl +
                    "/_api/web/lists/getByTitle('" + title + "')",
                type: "DELETE",
                headers: {
                    "accept": "application/json;odata=verbose",
                    "X-RequestDigest": $("#__REQUESTDIGEST").val(),
                    "IF-MATCH": "*"
                }
            }
        );

        return deferred.promise()

    },

    read = function (title) {
        var deferred = $.ajax(
            {
                url: _spPageContextInfo.webServerRelativeUrl +
                    "/_api/web/lists/getByTitle('" + title + "')",
                type: "GET",
                headers: {
                    "accept": "application/json;odata=verbose",
                }
            }
        );

        return deferred.promise()

    },

    options = function (title, quickLaunch, attachments, versions) {
        var deferred = $.ajax({
            url: _spPageContextInfo.webServerRelativeUrl +
                "/_api/web/lists/getByTitle('" + title + "')",
            type: "POST",
            contentType: "application/json;odata=verbose",
            data: JSON.stringify(
                {
                    '__metadata': {
                        'type': 'SP.List'
                    },
                    'OnQuickLaunch': quickLaunch,
                    'EnableAttachments': attachments,
                    'EnableVersioning': versions
                }),
            headers: {
                "accept": "application/json;odata=verbose",
                "X-RequestDigest": $("#__REQUESTDIGEST").val(),
                "IF-MATCH": "*",
                "X-Http-Method": "PATCH"
            }
        });

        return deferred.promise()
    },

    getContentType = function (contentTypeId) {
        var deferred = $.ajax(
            {
                url: _spPageContextInfo.webServerRelativeUrl +
                    "/_api/web/contentTypes/getById('" + contentTypeId + "')",
                type: "GET",
                headers: {
                    "accept": "application/json;odata=verbose",
                }
            }
        );

        return deferred.promise()
    },

    createContentType = function (contentTypeName, description, parentId, local) {

        var scope;
        if (local === true) {
            scope = "/_api/web/contentTypes";
        }
        else {
            scope = "/_api/site/rootWeb/contentTypes";
        }

        var deferred = $.ajax({
            url: _spPageContextInfo.webServerRelativeUrl + scope,
            type: "POST",
            contentType: "application/json;odata=verbose",
            data: JSON.stringify(
                {
                    '__metadata': { 'type': 'SP.ContentType' },
                    'Name': contentTypeName,
                    'Description': description,
                    'Id': {
                        '__metadata': { 'type': 'SP.ContentTypeId' },
                        'StringValue': createCTypeId(parentId)
                        }
                }),
            headers: {
                "accept": "application/json;odata=verbose",
                "X-RequestDigest": $("#__REQUESTDIGEST").val()
            }
        });

        return deferred.promise()
    },

    createCTypeId = function (parentId) {
        var id = parentId + "00";
        for (var i = 0; i < 9; i++) {
            id += (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
        }
        return id;
    },

    addFieldLink = function (contentTypeId, internalFieldName, local) {

        //CAN'T GET THIS CALL TO WORK!!

        var scope;
        if (local === true) {
            scope = "/_api/web/contentTypes";
        }
        else {
            scope = "/_api/site/rootWeb/contentTypes";
        }


        var deferred = $.ajax({
            url: _spPageContextInfo.webServerRelativeUrl + scope + 
                "/getById('" + contentTypeId + "')/fieldlinks",
            type: "POST",
            contentType: "application/json;odata=verbose",
            data: JSON.stringify(
                {
                    '__metadata': {
                        'type': 'SP.FieldLink'
                    },
                    'Name': internalFieldName
                }),
            headers: {
                "accept": "application/json;odata=verbose",
                "X-RequestDigest": $("#__REQUESTDIGEST").val()
            }
        });

        return deferred.promise()

    };

    return {
        create: create,
        remove: remove,
        read: read,
        options: options,
        get_contentType: getContentType,
        create_contentType: createContentType,
        add_fieldLink: addFieldLink
    };

}();