﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Microsoft.SharePoint.Client;

namespace ManagedCSOMWeb.Pages
{
    public partial class Collections : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            string appWebUrl = Page.Request["SPAppWebUrl"];
            using (ClientContext ctx = new ClientContext(appWebUrl))
            {
                //Method Syntax
                ctx.Load(ctx.Web,
                         w => w.Lists.Include(l => l.Title).Where(l => l.Title != null));
                ctx.ExecuteQuery();

                foreach (List list in ctx.Web.Lists)
                {
                    Console.WriteLine(list.Title);
                }

                //Query Syntax
                var q = from l in ctx.Web.Lists
                        where l.Title != null
                        select l;

                var r = ctx.LoadQuery(q);
                ctx.ExecuteQuery();

                Response.Write("<ul>");

                foreach (var i in r)
                {
                    Response.Write("<li>");
                    Response.Write(i.Title);
                    Response.Write("</li>");
                }
                Response.Write("</ul>");

            }
        }
    }
}