﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Microsoft.SharePoint.Client;

namespace ManagedCSOMWeb.Pages
{
    public partial class CreateList : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            string appWebUrl = Page.Request["SPAppWebUrl"];
            using (ClientContext ctx = new ClientContext(appWebUrl))
            {
                //Create a new list
                ListCreationInformation listCI = new ListCreationInformation();
                listCI.Title = "My List";
                listCI.Description += "A list for use with the Client OM";
                listCI.TemplateType = (int)ListTemplateType.GenericList;
                listCI.QuickLaunchOption = Microsoft.SharePoint.Client.QuickLaunchOptions.On;
                List list = ctx.Web.Lists.Add(listCI);
                ctx.ExecuteQuery();

                //Create a new list item
                ListItemCreationInformation listItemCI = new ListItemCreationInformation();
                Microsoft.SharePoint.Client.ListItem item = list.AddItem(listItemCI);
                item["Title"] = "New Item";
                item.Update();
                ctx.ExecuteQuery();
            }

        }
    }
}